//+------------------------------------------------------------------+
//|                                      2Extreme4U Grid Builder.mq4 |
//|                     Copyright  2005, Siddiqi, Alejandro Galindo |
//|                                              http://elCactus.com |
//|                                                                  |
//|   + modified for Alerter by Tesla                                |
//|                                                      hapalkos    |
//|                                                      2007.03.23  |
//+------------------------------------------------------------------+

#property indicator_chart_window
extern color  exGridColor = DarkViolet;
extern int    GridSpace   = 25;
extern string Name        = "RN20";
//extern int AlertBand = 10;       // NOTE: Enter the number of pips from the gridline that you want the Alert to activate.
                                 // NOTE: Added AlertBand for use with Alerter.

double lastLowPrice=999999,lastHighPrice=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  del_obj(Name);
  
  // draw grid lines at init only, no need to update them every tick!
  lastLowPrice=999999;
  lastHighPrice=0;
  draw_grid();

  return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  del_obj(Name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  if (High[0]>lastHighPrice || Low[0]<lastLowPrice) draw_grid();

//  Comment("low="+lastLowPrice+",high="+lastHighPrice);

  static datetime lasttime=0;
  // update grid lines every new bar only
  if ((TimeCurrent()-lasttime) < Period()*60) return;
  lasttime = TimeCurrent();

}

//+------------------------------------------------------------------+
int draw_grid()
//+------------------------------------------------------------------+
{
  //int    counted_bars=IndicatorCounted();
  double I=0,cnt=0;
  double LowPrice,HighPrice;
  double div;
  bool update_needed = false;

  double g = GridSpace;
  
  if (Digits<=1) div = g/1; // 0 digit pips
  else if (Digits<=3) div = g/100; // 2 digits pips
  else div = g/10000; // 4 digits pips

  // get highest and lowest prices on chart; exclude first few(6) bars, they might have ridiculously high/low values!
  int h=iHighest(NULL,0,MODE_HIGH, Bars - 6, 0);
  lastHighPrice = High[h];
  HighPrice = MathRound(High[h] / div) +4;


  int l=iLowest(NULL,0,MODE_LOW, Bars - 6, 0);
  lastLowPrice = Low[l];
  LowPrice = MathRound(Low[l] / div) -4;

  for(I=LowPrice;I<=HighPrice;I++) {
    string obj = Name+DoubleToStr(I*div,4);
    if (ObjectFind(obj) != 0) {
      cnt++;
      ObjectCreate(obj, OBJ_HLINE, 0, Time[1], I*div);
      ObjectSet(obj, OBJPROP_STYLE, STYLE_DOT);
      ObjectSet(obj, OBJPROP_COLOR,   exGridColor);
      string gridnamedesc = "";
      ObjectSetText(obj,gridnamedesc,10,"Arial",Black);
      ObjectSet(obj,OBJPROP_BACK, true);// for use with Tesla's Alerter indicator.
    }
  }

//  Print("draw_grid() at ",TimeToStr(lasttime,TIME_SECONDS),": ",cnt," new lines");
  
  return(0);
}

//+------------------------------------------------------------------+
void del_obj (string prefix)
//+------------------------------------------------------------------+
{
  string ObjName;
  int ObjTotal = ObjectsTotal();
  for(int i = ObjTotal-1; i>=0; i--) {
    ObjName = ObjectName(i);
    if(StringFind(ObjName,prefix,0)!=-1) ObjectDelete(ObjName);
  }
  return(0);
}/*del_obj*/

//end

